
org  0x7c00           ;//    
jmp  @start           ;//   -

header        db  '*** [ CodebyOS ] *** : ver0.2 Build 05.2025'
hLen          =   $ - header
bootDev       db  ' Boot device: USB-Flash'
bootDevLen    =   $ - bootDev
loadOs        db  ' Load OS into memory? y/n...'
loadOsLen     =   $ - loadOs

align    4
@start:  xor    ax,ax        ;//   
         mov    ds,ax        ;//   !
         mov    es,ax
         mov    ss,ax
         mov    sp,0x7c00    ;//   SS:SP
         sub    sp,4         ;//

;//  - 8025   
         mov    ax,3
         int    10h
         mov    ah,1
         mov    cx,0x2000
         int    10h

;//     
         push   es 0 0xb800    ;// 0xb800 =  /
         pop    es di          ;// ES:DI =     
         mov    cx,80          ;//    
         mov    al,' '         ;//  
         mov    ah,01001111b   ;// :     
         rep    stosw          ;//  AX  /!

;//    
         mov    si,header      ;// 
         mov    cx,hLen        ;//  
         mov    di,36          ;//   
@@:      lodsb                 ;//    DS:SI  1-,
         stosw                 ;//    / ES:DI  2- ( )
         loop   @b             ;//  -..

;//      
         mov    ah,00110000b   ;// :   
         mov    di,164         ;//   : (80*2)+4 = (2)
         mov    al,' '         ;//  
         mov    bp,7           ;//   
@@:      mov    cx,10          ;//   
         rep    stosw          ;//  !
         add    di,2           ;//   
         dec    bp             ;//  -1
         jnz    @b             ;// ,     

;//     
         mov    ah,00000111b   ;//   
         mov    di,(160*4)     ;//    = (4)
         mov    si,bootDev     ;//    
         mov    cx,bootDevLen  ;//  
@@:      lodsb                 ;//   !
         stosw
         loop   @b

;//     
         mov    di,(160*5)     ;//    = (5)
         mov    si,loadOs
         mov    cx,bootDevLen
@@:      lodsb
         stosw
         loop   @b

         pop    es

@@:      xor    ax,ax
         int    16h
         cmp    al,'y'
         jnz    @b

;//  AH=42h    
;//      INT-13h (. .417)
;//---------------------------------------------------------------
;DiskPacket:
;SizeOf        dw  16       ;//  
;Counter       dw  32       ;//   R/W
;BuffOffs      dw  0x0600   ;//   -,
;BuffSeg       dw  0        ;// ...  .
;StartLBA      dd  0,0      ;// 64- LBA  -

         mov    ax,word[$$+0x01c6]  ;// StartLBA    
         pushd  0           ;// StartLBA Hight
         push   0 ax        ;// StartLBA Low
         push   0           ;// Buffer Segment
         push   0x0600      ;// Buffer Offset
         push   32          ;// Sector Counter
         push   16          ;// Sizeof Packet

         mov    ah,42h         ;//  42h =    
         xor    dh,dh          ;//
         mov    dl,0x80        ;//  
         mov    si,sp          ;//   
         int    13h            ;//   
         add    sp,16          ;//    '

         push   cs 0x0600      ;//    !
         retf
;//-------------------------------------------------------------------
;//      512- 
;//-------------------------------------------------------------------
times    510-($-$$) db 0
dw       0xAA55           ;//<---    Boot- 55AAh







